/*
	qfcc.h

	#DESCRIPTION#

	Copyright (C) 2001 #AUTHOR#

	Author: #AUTHOR#
	Date: #DATE#

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	See the GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place - Suite 330
		Boston, MA  02111-1307, USA

	$Id$
*/

#ifndef __qfcc_h
#define __qfcc_h

#include "QF/pr_comp.h"

//============================================================================

#define	MAX_REGS		65536

//=============================================================================

//
// output generated by prog parsing
//
typedef struct {
	struct type_s	*types;
	
	struct def_s	*def_head;		// unused head of linked list
	struct def_s	**def_tail;		// add new defs after this and move it

	char			*strings;
	int				strofs;
	int				strings_size;

	dstatement_t	*statements;
	int				*statement_linenums;
	int				num_statements;
	int				statements_size;

	struct function_s *function_list;
	dfunction_t		*functions;
	int				num_functions;

	float			*globals;
	int				num_globals;
	int				globals_size;

	int				size_fields;
} pr_info_t;

extern	pr_info_t	pr;

//============================================================================

extern	char		destfile[];
extern	int			pr_source_line;

extern	struct def_s *pr_scope;
extern	int		pr_error_count;

#define	G_FLOAT(o)		(pr.globals[o])
#define	G_INT(o)		(*(int *)&pr.globals[o])
#define	G_VECTOR(o)		(&pr.globals[o])
#define	G_STRING(o)		(pr.strings + *(string_t *)&pr.globals[o])
#define	G_FUNCTION(o)	(*(func_t *)&pr.globals[o])
#define G_STRUCT(t,o)	(*(t *)&pr.globals[o])

extern	string_t	s_file;			// filename for function definition

const char *strip_path (const char *filename);

#endif//__qfcc_h
